<?php

namespace ImageSearch\Request\V20190325;

/**
 * @deprecated Please use https://github.com/aliyun/openapi-sdk-php
 *
 * Request of SearchImage
 *
 * @method string getFilter()
 * @method string getPicContent()
 * @method string getInstanceName()
 * @method string getProductId()
 * @method string getNum()
 * @method string getPicName()
 * @method string getStart()
 * @method string getRegion()
 * @method string getType()
 * @method string getCategoryId()
 * @method string getCrop()
 */
class SearchImageRequest extends \RoaAcsRequest
{

    /**
     * @var string
     */
    protected $uriPattern = '/v2/image/search';

    /**
     * @var string
     */
    protected $method = 'POST';

    /**
     * Class constructor.
     */
    public function __construct()
    {
        parent::__construct(
            'ImageSearch',
            '2019-03-25',
            'SearchImage',
            'imagesearch'
        );
    }

    /**
     * @param string $filter
     *
     * @return $this
     */
    public function setFilter($filter)
    {
        $this->requestParameters['Filter'] = $filter;

        return $this;
    }

    /**
     * @param string $picContent
     *
     * @return $this
     */
    public function setPicContent($picContent)
    {
        $this->requestParameters['PicContent'] = $picContent;

        return $this;
    }

    /**
     * @param string $instanceName
     *
     * @return $this
     */
    public function setInstanceName($instanceName)
    {
        $this->requestParameters['InstanceName'] = $instanceName;

        return $this;
    }

    /**
     * @param string $productId
     *
     * @return $this
     */
    public function setProductId($productId)
    {
        $this->requestParameters['ProductId'] = $productId;

        return $this;
    }

    /**
     * @param string $num
     *
     * @return $this
     */
    public function setNum($num)
    {
        $this->requestParameters['Num'] = $num;

        return $this;
    }

    /**
     * @param string $picName
     *
     * @return $this
     */
    public function setPicName($picName)
    {
        $this->requestParameters['PicName'] = $picName;

        return $this;
    }

    /**
     * @param string $start
     *
     * @return $this
     */
    public function setStart($start)
    {
        $this->requestParameters['Start'] = $start;

        return $this;
    }

    /**
     * @param string $region
     *
     * @return $this
     */
    public function setRegion($region)
    {
        $this->requestParameters['Region'] = $region;

        return $this;
    }

    /**
     * @param string $type
     *
     * @return $this
     */
    public function setType($type)
    {
        $this->requestParameters['Type'] = $type;
        $this->queryParameters['Type'] = $type;

        return $this;
    }

    /**
     * @param string $categoryId
     *
     * @return $this
     */
    public function setCategoryId($categoryId)
    {
        $this->requestParameters['CategoryId'] = $categoryId;

        return $this;
    }

    /**
     * @param string $crop
     *
     * @return $this
     */
    public function setCrop($crop)
    {
        $this->requestParameters['Crop'] = $crop;

        return $this;
    }
}
